<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>ProjectACES: include/dijkstra.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">ProjectACES
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">dijkstra.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="dijkstra_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef DIJKSTRA_DIJKSTRA_H</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define DIJKSTRA_DIJKSTRA_H</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#define int_pair pair&lt;int,int&gt;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#define double_pair pair&lt;int_pair,int_pair&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="structDijkstra__node.html">   24</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structDijkstra__node.html">Dijkstra_node</a> {</div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="structDijkstra__node.html#aa624c7af841e2ec465496776f494f8b5">   25</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="structDijkstra__node.html#aa624c7af841e2ec465496776f494f8b5">row</a>;    </div>
<div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="structDijkstra__node.html#a3dad7d972b5f93608cf2998cfe9f2c98">   26</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="structDijkstra__node.html#a3dad7d972b5f93608cf2998cfe9f2c98">col</a>;    </div>
<div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="structDijkstra__node.html#aaa425cda19cfa6c2c7795805da27ea3b">   27</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="structDijkstra__node.html#aaa425cda19cfa6c2c7795805da27ea3b">dist</a>;   </div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="structDijkstra__node.html#a924c56b2810b43810acff0073829f5ef">   34</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="structDijkstra__node.html#a924c56b2810b43810acff0073829f5ef">operator&lt;</a>(<span class="keyword">const</span> <a class="code" href="structDijkstra__node.html">Dijkstra_node</a> &amp;other)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="structDijkstra__node.html#aaa425cda19cfa6c2c7795805da27ea3b">dist</a> &lt; other.<a class="code" href="structDijkstra__node.html#aaa425cda19cfa6c2c7795805da27ea3b">dist</a>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    }</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="structDijkstra__node.html#aa6aae890018da4a85d21789e3330b2ea">   43</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="structDijkstra__node.html#aa6aae890018da4a85d21789e3330b2ea">operator==</a>(<span class="keyword">const</span> <a class="code" href="structDijkstra__node.html">Dijkstra_node</a> &amp;other)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keywordflow">return</span> (<a class="code" href="structDijkstra__node.html#aa624c7af841e2ec465496776f494f8b5">row</a> == other.<a class="code" href="structDijkstra__node.html#aa624c7af841e2ec465496776f494f8b5">row</a> &amp;&amp; <a class="code" href="structDijkstra__node.html#a3dad7d972b5f93608cf2998cfe9f2c98">col</a> == other.<a class="code" href="structDijkstra__node.html#a3dad7d972b5f93608cf2998cfe9f2c98">col</a>);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    }</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="structDijkstra__node.html#ae55077460d68aa1afe07b0e8080d0c62">   52</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="structDijkstra__node.html#ae55077460d68aa1afe07b0e8080d0c62">operator!=</a>(<span class="keyword">const</span> <a class="code" href="structDijkstra__node.html">Dijkstra_node</a> &amp;other)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="keywordflow">return</span> (<a class="code" href="structDijkstra__node.html#aa624c7af841e2ec465496776f494f8b5">row</a> != other.<a class="code" href="structDijkstra__node.html#aa624c7af841e2ec465496776f494f8b5">row</a> || <a class="code" href="structDijkstra__node.html#a3dad7d972b5f93608cf2998cfe9f2c98">col</a> != other.<a class="code" href="structDijkstra__node.html#a3dad7d972b5f93608cf2998cfe9f2c98">col</a>);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    }</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;};</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classDijkstra.html">   61</a></span>&#160;<span class="keyword">class </span><a class="code" href="classDijkstra.html">Dijkstra</a> {</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="classDijkstra.html#a7994b590ca8f02bf1577adec2d5ac1c5">   63</a></span>&#160;    <span class="keywordtype">int</span> **<a class="code" href="classDijkstra.html#a7994b590ca8f02bf1577adec2d5ac1c5">visited</a>;  </div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="classDijkstra.html#a4c6686b282d5cf37a96c8c216dc84bef">   64</a></span>&#160;    <span class="keywordtype">int</span> **<a class="code" href="classDijkstra.html#a4c6686b282d5cf37a96c8c216dc84bef">maze</a>;     </div>
<div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="classDijkstra.html#a038c1f4d110df6114080878c74039fcf">   65</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classDijkstra.html#a038c1f4d110df6114080878c74039fcf">nr_nodes</a>;   </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keyword">struct </span><a class="code" href="structDijkstra__node.html">Dijkstra_node</a> <a class="code" href="classDijkstra.html#a324563e8b4f66022c85870e71064e38e">starting_node</a>; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">struct </span><a class="code" href="structDijkstra__node.html">Dijkstra_node</a> <a class="code" href="classDijkstra.html#a6cd0a788a66dc3c191d38050337687de">target_node</a>;   </div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <a class="code" href="classDijkstra.html#a4d2309428b0fb6a81f19fa3d7cd8a9c1">Dijkstra</a>(<span class="keywordtype">int</span> v_nr_nodes);</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <a class="code" href="classDijkstra.html#a4d2309428b0fb6a81f19fa3d7cd8a9c1">Dijkstra</a>(<span class="keywordtype">int</span> **v_maze, <span class="keywordtype">int</span> v_nr_nodes);</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <a class="code" href="classDijkstra.html#a5f4a99a63b92805a304dea947ac69db5">~Dijkstra</a>();</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classDijkstra.html#a4c13d9d8d5166d78e7b1827a3bfdb42a">solve_dijkstra</a>();</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDijkstra.html#aeb48f10e0a5d100eadde3084c1055b9f">alloc_mem</a>();</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;};</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160; </div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="keywordtype">int</span> **<a class="code" href="dijkstra_8hpp.html#ad8adb627af69a5ca371972a3c7e4f598">alloc_mem_matrix</a>(<span class="keywordtype">int</span> nr_nodes);</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160; </div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="keywordtype">int</span> <a class="code" href="dijkstra_8hpp.html#a8785d51320fbcb9c339b45237444ced9">are_valid_nodes</a>(<span class="keywordtype">int</span>, <span class="keywordtype">int</span>, <span class="keywordtype">int</span>, <span class="keywordtype">int</span>, <span class="keywordtype">int</span>);</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160; </div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="preprocessor">#endif </span><span class="comment">//DIJKSTRA_DIJKSTRA_H</span></div>
<div class="ttc" id="aclassDijkstra_html"><div class="ttname"><a href="classDijkstra.html">Dijkstra</a></div><div class="ttdoc">Dijkstra class.</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:61</div></div>
<div class="ttc" id="aclassDijkstra_html_a038c1f4d110df6114080878c74039fcf"><div class="ttname"><a href="classDijkstra.html#a038c1f4d110df6114080878c74039fcf">Dijkstra::nr_nodes</a></div><div class="ttdeci">int nr_nodes</div><div class="ttdoc">The size of the maze.</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:65</div></div>
<div class="ttc" id="aclassDijkstra_html_a324563e8b4f66022c85870e71064e38e"><div class="ttname"><a href="classDijkstra.html#a324563e8b4f66022c85870e71064e38e">Dijkstra::starting_node</a></div><div class="ttdeci">struct Dijkstra_node starting_node</div><div class="ttdoc">Starting node in the maze.</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:67</div></div>
<div class="ttc" id="aclassDijkstra_html_a4c13d9d8d5166d78e7b1827a3bfdb42a"><div class="ttname"><a href="classDijkstra.html#a4c13d9d8d5166d78e7b1827a3bfdb42a">Dijkstra::solve_dijkstra</a></div><div class="ttdeci">int solve_dijkstra()</div><div class="ttdoc">Function for solving the maze.</div><div class="ttdef"><b>Definition:</b> dijkstra.cpp:55</div></div>
<div class="ttc" id="aclassDijkstra_html_a4c6686b282d5cf37a96c8c216dc84bef"><div class="ttname"><a href="classDijkstra.html#a4c6686b282d5cf37a96c8c216dc84bef">Dijkstra::maze</a></div><div class="ttdeci">int ** maze</div><div class="ttdoc">The maze.</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:64</div></div>
<div class="ttc" id="aclassDijkstra_html_a4d2309428b0fb6a81f19fa3d7cd8a9c1"><div class="ttname"><a href="classDijkstra.html#a4d2309428b0fb6a81f19fa3d7cd8a9c1">Dijkstra::Dijkstra</a></div><div class="ttdeci">Dijkstra(int v_nr_nodes)</div><div class="ttdoc">Constructor for random generation.</div><div class="ttdef"><b>Definition:</b> dijkstra.cpp:30</div></div>
<div class="ttc" id="aclassDijkstra_html_a5f4a99a63b92805a304dea947ac69db5"><div class="ttname"><a href="classDijkstra.html#a5f4a99a63b92805a304dea947ac69db5">Dijkstra::~Dijkstra</a></div><div class="ttdeci">~Dijkstra()</div><div class="ttdoc">Destructor.</div><div class="ttdef"><b>Definition:</b> dijkstra.cpp:51</div></div>
<div class="ttc" id="aclassDijkstra_html_a6cd0a788a66dc3c191d38050337687de"><div class="ttname"><a href="classDijkstra.html#a6cd0a788a66dc3c191d38050337687de">Dijkstra::target_node</a></div><div class="ttdeci">struct Dijkstra_node target_node</div><div class="ttdoc">Target node in the maze.</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:68</div></div>
<div class="ttc" id="aclassDijkstra_html_a7994b590ca8f02bf1577adec2d5ac1c5"><div class="ttname"><a href="classDijkstra.html#a7994b590ca8f02bf1577adec2d5ac1c5">Dijkstra::visited</a></div><div class="ttdeci">int ** visited</div><div class="ttdoc">The visited nodes.</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:63</div></div>
<div class="ttc" id="aclassDijkstra_html_aeb48f10e0a5d100eadde3084c1055b9f"><div class="ttname"><a href="classDijkstra.html#aeb48f10e0a5d100eadde3084c1055b9f">Dijkstra::alloc_mem</a></div><div class="ttdeci">void alloc_mem()</div><div class="ttdoc">Function for allocating attributes to memory.</div><div class="ttdef"><b>Definition:</b> dijkstra.cpp:25</div></div>
<div class="ttc" id="adijkstra_8hpp_html_a8785d51320fbcb9c339b45237444ced9"><div class="ttname"><a href="dijkstra_8hpp.html#a8785d51320fbcb9c339b45237444ced9">are_valid_nodes</a></div><div class="ttdeci">int are_valid_nodes(int, int, int, int, int)</div><div class="ttdoc">Sanity check function.</div><div class="ttdef"><b>Definition:</b> dijkstra.cpp:141</div></div>
<div class="ttc" id="adijkstra_8hpp_html_ad8adb627af69a5ca371972a3c7e4f598"><div class="ttname"><a href="dijkstra_8hpp.html#ad8adb627af69a5ca371972a3c7e4f598">alloc_mem_matrix</a></div><div class="ttdeci">int ** alloc_mem_matrix(int nr_nodes)</div><div class="ttdoc">Function for allocating variables to memory.</div><div class="ttdef"><b>Definition:</b> dijkstra.cpp:18</div></div>
<div class="ttc" id="astructDijkstra__node_html"><div class="ttname"><a href="structDijkstra__node.html">Dijkstra_node</a></div><div class="ttdoc">Dijkstra_node struct.</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:24</div></div>
<div class="ttc" id="astructDijkstra__node_html_a3dad7d972b5f93608cf2998cfe9f2c98"><div class="ttname"><a href="structDijkstra__node.html#a3dad7d972b5f93608cf2998cfe9f2c98">Dijkstra_node::col</a></div><div class="ttdeci">int col</div><div class="ttdoc">the COLUMN in the maze</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:26</div></div>
<div class="ttc" id="astructDijkstra__node_html_a924c56b2810b43810acff0073829f5ef"><div class="ttname"><a href="structDijkstra__node.html#a924c56b2810b43810acff0073829f5ef">Dijkstra_node::operator&lt;</a></div><div class="ttdeci">bool operator&lt;(const Dijkstra_node &amp;other) const</div><div class="ttdoc">Operator &lt; is overwritten for sorting the list of nodes that we should search next.</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:34</div></div>
<div class="ttc" id="astructDijkstra__node_html_aa624c7af841e2ec465496776f494f8b5"><div class="ttname"><a href="structDijkstra__node.html#aa624c7af841e2ec465496776f494f8b5">Dijkstra_node::row</a></div><div class="ttdeci">int row</div><div class="ttdoc">the ROW in the maze</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:25</div></div>
<div class="ttc" id="astructDijkstra__node_html_aa6aae890018da4a85d21789e3330b2ea"><div class="ttname"><a href="structDijkstra__node.html#aa6aae890018da4a85d21789e3330b2ea">Dijkstra_node::operator==</a></div><div class="ttdeci">bool operator==(const Dijkstra_node &amp;other) const</div><div class="ttdoc">Operator == is overwritten for checking if 2 nodes are the same.</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:43</div></div>
<div class="ttc" id="astructDijkstra__node_html_aaa425cda19cfa6c2c7795805da27ea3b"><div class="ttname"><a href="structDijkstra__node.html#aaa425cda19cfa6c2c7795805da27ea3b">Dijkstra_node::dist</a></div><div class="ttdeci">int dist</div><div class="ttdoc">the DISTANCE in the from the starting node to the current node</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:27</div></div>
<div class="ttc" id="astructDijkstra__node_html_ae55077460d68aa1afe07b0e8080d0c62"><div class="ttname"><a href="structDijkstra__node.html#ae55077460d68aa1afe07b0e8080d0c62">Dijkstra_node::operator!=</a></div><div class="ttdeci">bool operator!=(const Dijkstra_node &amp;other) const</div><div class="ttdoc">Operator != is overwritten for checking if 2 nodes are not the same.</div><div class="ttdef"><b>Definition:</b> dijkstra.hpp:52</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
